diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
similarity index 86%
rename from src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
rename to src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
index 4184689ad..af75de9de 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/PacketHandlerClient.java
@@ -3,43 +3,43 @@ package net.minecraft.client.net.handler;
 import com.b100.utils.StringUtils;
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.particle.TakeAnimationParticle;
-import net.minecraft.client.entity.player.LocalPlayer;
-import net.minecraft.client.entity.player.RemotePlayer;
-import net.minecraft.client.gui.ConnectFailedScreen;
-import net.minecraft.client.gui.DownloadTerrainScreen;
-import net.minecraft.client.gui.PauseScreen;
-import net.minecraft.client.gui.chat.ChatSuggestionsElement;
-import net.minecraft.client.gui.guidebook.GuidebookScreen;
-import net.minecraft.client.gui.guidebook.PageManager;
-import net.minecraft.client.gui.guidebook.search.SearchPage;
+import net.minecraft.client.entity.particle.ParticlePickupAnimation;
+import net.minecraft.client.entity.player.PlayerLocal;
+import net.minecraft.client.entity.player.PlayerRemote;
+import net.minecraft.client.gui.ScreenConnectFailed;
+import net.minecraft.client.gui.ScreenDownloadTerrain;
+import net.minecraft.client.gui.ScreenPause;
+import net.minecraft.client.gui.chat.GuiElementChatSuggestions;
+import net.minecraft.client.gui.guidebook.GuidebookPageManager;
+import net.minecraft.client.gui.guidebook.ScreenGuidebook;
+import net.minecraft.client.gui.guidebook.search.GuidebookPageSearch;
 import net.minecraft.client.player.controller.PlayerControllerMP;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.achievement.stat.StatList;
-import net.minecraft.core.block.entity.ActivatorBlockEntity;
-import net.minecraft.core.block.entity.BlockEntity;
-import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
-import net.minecraft.core.block.entity.BlockEntityDispatcher;
-import net.minecraft.core.block.entity.DispenserBlockEntity;
-import net.minecraft.core.block.entity.FlagBlockEntity;
-import net.minecraft.core.block.entity.MobSpawnerBlockEntity;
-import net.minecraft.core.block.entity.FurnaceBlockEntity;
-import net.minecraft.core.block.entity.TrommelBlockEntity;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.TileEntityFurnaceBlastFurnace;
+import net.minecraft.core.block.entity.TileEntityDispatcher;
+import net.minecraft.core.block.entity.TileEntityDispenser;
+import net.minecraft.core.block.entity.TileEntityFlag;
+import net.minecraft.core.block.entity.TileEntityMobSpawner;
+import net.minecraft.core.block.entity.TileEntityFurnace;
+import net.minecraft.core.block.entity.TileEntityTrommel;
 import net.minecraft.core.data.DataLoader;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.data.registry.recipe.RecipeRegistry;
 import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
-import net.minecraft.core.entity.ItemEntity;
-import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.entity.EntityItem;
+import net.minecraft.core.entity.EntityLightning;
 import net.minecraft.core.entity.Mob;
-import net.minecraft.core.entity.PaintingEntity;
+import net.minecraft.core.entity.EntityPainting;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.Projectile;
 import net.minecraft.core.enums.ArtType;
-import net.minecraft.core.item.MapItem;
+import net.minecraft.core.item.ItemMap;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.net.NetworkManager;
@@ -48,8 +48,8 @@ import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.handler.PacketHandler;
 import net.minecraft.core.net.packet.*;
 import net.minecraft.core.player.gamemode.Gamemode;
-import net.minecraft.core.player.inventory.menu.AbstractContainerMenu;
-import net.minecraft.core.player.inventory.container.SimpleContainer;
+import net.minecraft.core.player.inventory.menu.MenuAbstract;
+import net.minecraft.core.player.inventory.container.ContainerSimple;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.util.helper.AES;
 import net.minecraft.core.util.helper.MathHelper;
@@ -78,7 +78,7 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Random;
 
-public class ClientPacketHandler extends PacketHandler
+public class PacketHandlerClient extends PacketHandler
 {
     private static final Logger LOGGER = LogUtils.getLogger();
     private boolean disconnected;
@@ -92,7 +92,7 @@ public class ClientPacketHandler extends PacketHandler
     public HashMap<String, String> playerList = new HashMap<>();
     Random rand;
 
-    public ClientPacketHandler(Minecraft minecraft, String host, int port)
+    public PacketHandlerClient(Minecraft minecraft, String host, int port)
             throws UnknownHostException, IOException
     {
         disconnected = false;
@@ -159,7 +159,7 @@ public class ClientPacketHandler extends PacketHandler
         worldClient.isClientSide = true;
         mc.changeWorld(worldClient);
         mc.thePlayer.dimension = loginPacket.dimensionId;
-        mc.displayScreen(new DownloadTerrainScreen(this));
+        mc.displayScreen(new ScreenDownloadTerrain(this));
         mc.thePlayer.id = loginPacket.playerEntityIdAndProtocolVersion;
         NetworkManager.PACKET_DELAY = loginPacket.packetDelay;
         Registries.RECIPES = new RecipeRegistry();
@@ -171,14 +171,14 @@ public class ClientPacketHandler extends PacketHandler
         double x = addItemEntityPacket.xPosition / 32D;
         double y = addItemEntityPacket.yPosition / 32D;
         double z = addItemEntityPacket.zPosition / 32D;
-        ItemEntity itemEntity = new ItemEntity(worldClient, x, y, z, new ItemStack(addItemEntityPacket.itemID, addItemEntityPacket.count, addItemEntityPacket.itemDamage, addItemEntityPacket.tag));
-        itemEntity.xd = (double) addItemEntityPacket.xd / 128D;
-        itemEntity.yd = (double) addItemEntityPacket.yd / 128D;
-        itemEntity.zd = (double) addItemEntityPacket.zd / 128D;
-        itemEntity.serverPosX = addItemEntityPacket.xPosition;
-        itemEntity.serverPosY = addItemEntityPacket.yPosition;
-        itemEntity.serverPosZ = addItemEntityPacket.zPosition;
-        worldClient.addEntityToWorld(addItemEntityPacket.entityId, itemEntity);
+        EntityItem entityItem = new EntityItem(worldClient, x, y, z, new ItemStack(addItemEntityPacket.itemID, addItemEntityPacket.count, addItemEntityPacket.itemDamage, addItemEntityPacket.tag));
+        entityItem.xd = (double) addItemEntityPacket.xd / 128D;
+        entityItem.yd = (double) addItemEntityPacket.yd / 128D;
+        entityItem.zd = (double) addItemEntityPacket.zd / 128D;
+        entityItem.serverPosX = addItemEntityPacket.xPosition;
+        entityItem.serverPosY = addItemEntityPacket.yPosition;
+        entityItem.serverPosZ = addItemEntityPacket.zPosition;
+        worldClient.addEntityToWorld(addItemEntityPacket.entityId, entityItem);
     }
 
 
@@ -220,7 +220,7 @@ public class ClientPacketHandler extends PacketHandler
         double z = (double) weatherEffectPacket.z / 32D;
         Entity weatherEntity = null;
         if (weatherEffectPacket.effectId == WeatherEffectPacket.EFFECT_LIGHTNING) {
-            weatherEntity = new LightningEntity(worldClient, x, y, z);
+            weatherEntity = new EntityLightning(worldClient, x, y, z);
         }
         if (weatherEntity != null)
         {
@@ -247,8 +247,8 @@ public class ClientPacketHandler extends PacketHandler
     public void handleEntityPainting(AddPaintingPacket addPaintingPacket)
     {
         Entity entity = worldClient.getEntityFromId(addPaintingPacket.entityId);
-        if (entity instanceof PaintingEntity){
-            PaintingEntity painting = (PaintingEntity) entity;
+        if (entity instanceof EntityPainting){
+            EntityPainting painting = (EntityPainting) entity;
             painting.blockX = addPaintingPacket.xPosition;
             painting.blockY = addPaintingPacket.yPosition;
             painting.blockZ = addPaintingPacket.zPosition;
@@ -260,7 +260,7 @@ public class ClientPacketHandler extends PacketHandler
                 painting.setStack(new ItemStack(addPaintingPacket.itemID, 1, addPaintingPacket.meta));
             }
         } else {
-            PaintingEntity entitypainting = new PaintingEntity(worldClient, addPaintingPacket.xPosition, addPaintingPacket.yPosition, addPaintingPacket.zPosition, addPaintingPacket.direction, addPaintingPacket.key);
+            EntityPainting entitypainting = new EntityPainting(worldClient, addPaintingPacket.xPosition, addPaintingPacket.yPosition, addPaintingPacket.zPosition, addPaintingPacket.direction, addPaintingPacket.key);
             worldClient.addEntityToWorld(addPaintingPacket.entityId, entitypainting);
             if (addPaintingPacket.itemID > 0){
                 entitypainting.setStack(new ItemStack(addPaintingPacket.itemID, 1, addPaintingPacket.meta));
@@ -302,25 +302,25 @@ public class ClientPacketHandler extends PacketHandler
         double d2 = (double) addPlayerPacket.zPosition / 32D;
         float f = (float) (addPlayerPacket.rotation * 360) / 256F;
         float f1 = (float) (addPlayerPacket.pitch * 360) / 256F;
-        RemotePlayer remotePlayer = new RemotePlayer(mc.theWorld, addPlayerPacket.name, addPlayerPacket.uuid);
-        remotePlayer.xo = remotePlayer.serverPosX = addPlayerPacket.xPosition;
-        remotePlayer.yo = remotePlayer.serverPosY = addPlayerPacket.yPosition;
-        remotePlayer.zo = remotePlayer.serverPosZ = addPlayerPacket.zPosition;
+        PlayerRemote playerRemote = new PlayerRemote(mc.theWorld, addPlayerPacket.name, addPlayerPacket.uuid);
+        playerRemote.xo = playerRemote.serverPosX = addPlayerPacket.xPosition;
+        playerRemote.yo = playerRemote.serverPosY = addPlayerPacket.yPosition;
+        playerRemote.zo = playerRemote.serverPosZ = addPlayerPacket.zPosition;
         int i = addPlayerPacket.currentItem;
         if (i == 0)
         {
-            remotePlayer.inventory.mainInventory[remotePlayer.inventory.getCurrentItemIndex()] = null;
+            playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentItemIndex()] = null;
         }
         else
         {
-            remotePlayer.inventory.mainInventory[remotePlayer.inventory.getCurrentItemIndex()] = new ItemStack(i, 1, 0);
+            playerRemote.inventory.mainInventory[playerRemote.inventory.getCurrentItemIndex()] = new ItemStack(i, 1, 0);
         }
-        remotePlayer.absMoveTo(d, d1, d2, f, f1);
-        worldClient.addEntityToWorld(addPlayerPacket.entityId, remotePlayer);
-        remotePlayer.nickname = StringUtils.substring(addPlayerPacket.nickname, 0, 32);
-        remotePlayer.chatColor = addPlayerPacket.chatColor;
+        playerRemote.absMoveTo(d, d1, d2, f, f1);
+        worldClient.addEntityToWorld(addPlayerPacket.entityId, playerRemote);
+        playerRemote.nickname = StringUtils.substring(addPlayerPacket.nickname, 0, 32);
+        playerRemote.chatColor = addPlayerPacket.chatColor;
 
-        remotePlayer.setHeldObject(addPlayerPacket.heldObjectTag == null ? null : ICarriable.createAndLoadCarriable(remotePlayer, addPlayerPacket.heldObjectTag));
+        playerRemote.setHeldObject(addPlayerPacket.heldObjectTag == null ? null : ICarriable.createAndLoadCarriable(playerRemote, addPlayerPacket.heldObjectTag));
     }
 
     @Override
@@ -382,10 +382,10 @@ public class ClientPacketHandler extends PacketHandler
     {
         if (mc.theWorld.isBlockLoaded(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition))
         {
-            BlockEntity tileentity = mc.theWorld.getBlockEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
-            if (tileentity instanceof MobSpawnerBlockEntity)
+            TileEntity tileentity = mc.theWorld.getBlockEntity(setMobSpawnerPacket.xPosition, setMobSpawnerPacket.yPosition, setMobSpawnerPacket.zPosition);
+            if (tileentity instanceof TileEntityMobSpawner)
             {
-                MobSpawnerBlockEntity tileEntityMobSpawner = (MobSpawnerBlockEntity) tileentity;
+                TileEntityMobSpawner tileEntityMobSpawner = (TileEntityMobSpawner) tileentity;
                 tileEntityMobSpawner.setMobId(setMobSpawnerPacket.spawnType);
 
                 tileEntityMobSpawner.setChanged();
@@ -407,7 +407,7 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleFlying(MovePlayerPacket movePlayerPacket)
     {
-        LocalPlayer entityplayersp = mc.thePlayer;
+        PlayerLocal entityplayersp = mc.thePlayer;
         double d = ((Player) (entityplayersp)).x;
         double d1 = ((Player) (entityplayersp)).y;
         double d2 = ((Player) (entityplayersp)).z;
@@ -486,7 +486,7 @@ public class ClientPacketHandler extends PacketHandler
         netManager.networkShutdown("disconnect.kicked", new Object[0]);
         disconnected = true;
         mc.changeWorld(null);
-        mc.displayScreen(new ConnectFailedScreen("disconnect.disconnected", "disconnect.genericReason", new Object[]{
+        mc.displayScreen(new ScreenConnectFailed("disconnect.disconnected", "disconnect.genericReason", new Object[]{
             packet255KickdisconnectPacket.reason
         }));
     }
@@ -507,7 +507,7 @@ public class ClientPacketHandler extends PacketHandler
                 LOGGER.error("Exception when leaving GUI!", e);
             }
 
-            mc.displayScreen(new ConnectFailedScreen("disconnect.lost", message, objects)); // Open error message gui
+            mc.displayScreen(new ScreenConnectFailed("disconnect.lost", message, objects)); // Open error message gui
         }
     }
 
@@ -540,7 +540,7 @@ public class ClientPacketHandler extends PacketHandler
             // this class does not seem to handle pick up from server dropped items. find where it is.
             // something about that isn't working on servers if the player changed their gamemode.
             worldClient.playSoundAtEntity(null, item, "item.pickup", 1F, ((rand.nextFloat() - rand.nextFloat()) * 0.7F + 1.0F) * 4.0F);
-            mc.particleEngine.add(new TakeAnimationParticle(mc.theWorld, item, collector, -0.5F));
+            mc.particleEngine.add(new ParticlePickupAnimation(mc.theWorld, item, collector, -0.5F));
             worldClient.removeEntityFromWorld(takeItemEntityPacket.collectedEntityId);
         }
     }
@@ -560,20 +560,20 @@ public class ClientPacketHandler extends PacketHandler
 		
 		int type = packet.type;
 		if(type == 1) {
-			mc.ingameHud.heldItemTooltipElement.setString(message);
+			mc.hudIngame.heldItemTooltipElement.setString(message);
 		}else {
-			mc.ingameHud.addChatMessage(message);
+			mc.hudIngame.addChatMessage(message);
 		}
 	}
 
     public void handlePlayerJoin(ChatPacket chatPacket)
     {
-        mc.ingameHud.addChatMessage(chatPacket.message);
+        mc.hudIngame.addChatMessage(chatPacket.message);
     }
 
     public void handlePlayerLeave(ChatPacket chatPacket)
     {
-        mc.ingameHud.addChatMessage(chatPacket.message);
+        mc.hudIngame.addChatMessage(chatPacket.message);
     }
 
     @Override
@@ -825,7 +825,7 @@ public class ClientPacketHandler extends PacketHandler
             worldClient.isClientSide = true;
             mc.changeWorld(worldClient);
             mc.thePlayer.dimension = respawnPacket.respawnDimensionId;
-            mc.displayScreen(new DownloadTerrainScreen(this));
+            mc.displayScreen(new ScreenDownloadTerrain(this));
         }
         mc.respawn(true, respawnPacket.respawnDimensionId);
     }
@@ -852,38 +852,38 @@ public class ClientPacketHandler extends PacketHandler
     {
         switch (containerOpenPacket.inventoryType) {
             case ContainerOpenPacket.TYPE_GENERIC_CONTAINER: {
-                SimpleContainer simpleContainer = new SimpleContainer(containerOpenPacket.windowTitle, containerOpenPacket.slotsCount);
+                ContainerSimple simpleContainer = new ContainerSimple(containerOpenPacket.windowTitle, containerOpenPacket.slotsCount);
                 mc.thePlayer.displayContainerScreen(simpleContainer);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
             case ContainerOpenPacket.TYPE_FURNACE: {
-                FurnaceBlockEntity furnaceBlockEntity = new FurnaceBlockEntity();
-                mc.thePlayer.displayFurnaceScreen(furnaceBlockEntity);
+                TileEntityFurnace tileEntityFurnace = new TileEntityFurnace();
+                mc.thePlayer.displayFurnaceScreen(tileEntityFurnace);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
             case ContainerOpenPacket.TYPE_DISPENSER: {
-                DispenserBlockEntity dispenserBlockEntity = new DispenserBlockEntity();
-                mc.thePlayer.displayDispenserScreen(dispenserBlockEntity);
+                TileEntityDispenser tileEntityDispenser = new TileEntityDispenser();
+                mc.thePlayer.displayDispenserScreen(tileEntityDispenser);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
             case ContainerOpenPacket.TYPE_ACTIVATOR: {
-                ActivatorBlockEntity activatorBlockEntity = new ActivatorBlockEntity();
-                mc.thePlayer.displayActivatorScreen(activatorBlockEntity);
+                TileEntityActivator tileEntityActivator = new TileEntityActivator();
+                mc.thePlayer.displayActivatorScreen(tileEntityActivator);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
             case ContainerOpenPacket.TYPE_BLAST_FURNACE: {
-                BlastFurnaceBlockEntity blastFurnaceBlockEntity = new BlastFurnaceBlockEntity();
-                mc.thePlayer.displayFurnaceScreen(blastFurnaceBlockEntity);
+                TileEntityFurnaceBlastFurnace tileEntityFurnaceBlast = new TileEntityFurnaceBlastFurnace();
+                mc.thePlayer.displayFurnaceScreen(tileEntityFurnaceBlast);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
             case ContainerOpenPacket.TYPE_TROMMEL: {
-                TrommelBlockEntity trommelBlockEntity = new TrommelBlockEntity();
-                mc.thePlayer.displayTrommelScreen(trommelBlockEntity);
+                TileEntityTrommel tileEntityTrommel = new TileEntityTrommel();
+                mc.thePlayer.displayTrommelScreen(tileEntityTrommel);
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
@@ -892,8 +892,8 @@ public class ClientPacketHandler extends PacketHandler
                 break;
             }
             case ContainerOpenPacket.TYPE_CRAFTING: {
-                LocalPlayer localPlayer = mc.thePlayer;
-                mc.thePlayer.displayWorkbenchScreen(MathHelper.floor(localPlayer.x), MathHelper.floor(localPlayer.y), MathHelper.floor(localPlayer.z));
+                PlayerLocal playerLocal = mc.thePlayer;
+                mc.thePlayer.displayWorkbenchScreen(MathHelper.floor(playerLocal.x), MathHelper.floor(playerLocal.y), MathHelper.floor(playerLocal.z));
                 mc.thePlayer.craftingInventory.containerId = containerOpenPacket.windowId;
                 break;
             }
@@ -906,10 +906,10 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleOpenFlagWindow(FlagOpenPacket flagOpenPacket)
     {
-        BlockEntity blockEntity = worldClient.getBlockEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
-        if (blockEntity instanceof FlagBlockEntity)
+        TileEntity tileEntity = worldClient.getBlockEntity(flagOpenPacket.x, flagOpenPacket.y, flagOpenPacket.z);
+        if (tileEntity instanceof TileEntityFlag)
         {
-            FlagBlockEntity tileEntityFlag = (FlagBlockEntity) blockEntity;
+            TileEntityFlag tileEntityFlag = (TileEntityFlag) tileEntity;
             mc.thePlayer.displayFlagEditorScreen(tileEntityFlag);
             mc.thePlayer.craftingInventory.containerId = flagOpenPacket.windowId;
         }
@@ -918,7 +918,7 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handlePhotoMode(PhotoModePacket photoModePacket)
     {
-        PauseScreen.photoModeDisabled = photoModePacket.disabled;
+        ScreenPause.photoModeDisabled = photoModePacket.disabled;
     }
 
     @Override
@@ -946,7 +946,7 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleTransaction(ContainerAckPacket containerAckPacket)
     {
-        AbstractContainerMenu container = null;
+        MenuAbstract container = null;
         if (containerAckPacket.windowId == 0)
         {
             container = mc.thePlayer.inventorySlots;
@@ -1037,7 +1037,7 @@ public class ClientPacketHandler extends PacketHandler
     {
         if (mapdataPacket.itemId == Items.MAP.id)
         {
-            MapItem.getOrCreateSavedData(mapdataPacket.meta, mapdataPacket.scale, mc.theWorld).setColors(mapdataPacket.mapData);
+            ItemMap.getOrCreateSavedData(mapdataPacket.meta, mapdataPacket.scale, mc.theWorld).setColors(mapdataPacket.mapData);
         }
         else
         {
@@ -1129,20 +1129,20 @@ public class ClientPacketHandler extends PacketHandler
     @Override
     public void handleTileEntityData(BlockEntityDataPacket blockEntityDataPacket)
     {
-        Class<?> clazz = BlockEntityDispatcher.getClassFromID(blockEntityDataPacket.tag.getString("id"));
+        Class<?> clazz = TileEntityDispatcher.getClassFromID(blockEntityDataPacket.tag.getString("id"));
         if (clazz == null) return;
-        BlockEntity existingBlockEntity = worldClient.getBlockEntity(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
-        if (existingBlockEntity == null || existingBlockEntity.getClass() != clazz)
+        TileEntity existingTileEntity = worldClient.getBlockEntity(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
+        if (existingTileEntity == null || existingTileEntity.getClass() != clazz)
         {
-            BlockEntity blockEntity = BlockEntityDispatcher.createAndLoadEntity(blockEntityDataPacket.tag);
-            if (blockEntity != null)
+            TileEntity tileEntity = TileEntityDispatcher.createAndLoadEntity(blockEntityDataPacket.tag);
+            if (tileEntity != null)
             {
-                mc.theWorld.setBlockTileEntity(blockEntity.x, blockEntity.y, blockEntity.z, blockEntity);
+                mc.theWorld.setBlockTileEntity(tileEntity.x, tileEntity.y, tileEntity.z, tileEntity);
             }
         }
         else
         {
-            existingBlockEntity.readFromNBT(blockEntityDataPacket.tag);
+            existingTileEntity.readFromNBT(blockEntityDataPacket.tag);
         }
         worldClient.markBlockDirty(blockEntityDataPacket.tag.getInteger("x"), blockEntityDataPacket.tag.getInteger("y"), blockEntityDataPacket.tag.getInteger("z"));
     }
@@ -1164,12 +1164,12 @@ public class ClientPacketHandler extends PacketHandler
         if(Registries.RECIPES.getAllSerializableRecipes().size() == recipeSyncPacket.maxRecipes){
             LOGGER.info("All recipes received!");
             Registries.RECIPES.invalidateCaches();
-            SearchPage.searchField.setText("_");
-            PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
-            GuidebookScreen.getPageManager().updatePages();
-            SearchPage.searchField.setText("");
-            PageManager.searchQuery = SearchQuery.resolve(SearchPage.searchField.getText());
-            GuidebookScreen.getPageManager().updatePages();
+            GuidebookPageSearch.searchField.setText("_");
+            GuidebookPageManager.searchQuery = SearchQuery.resolve(GuidebookPageSearch.searchField.getText());
+            ScreenGuidebook.getPageManager().updatePages();
+            GuidebookPageSearch.searchField.setText("");
+            GuidebookPageManager.searchQuery = SearchQuery.resolve(GuidebookPageSearch.searchField.getText());
+            ScreenGuidebook.getPageManager().updatePages();
         }
     }
     
@@ -1190,6 +1190,6 @@ public class ClientPacketHandler extends PacketHandler
 
     @Override
     public void handleCommandManagerPacket(CommandManagerPacket commandManagerPacket) {
-        ChatSuggestionsElement.serverSuggestions = commandManagerPacket.suggestions;
+        GuiElementChatSuggestions.serverSuggestions = commandManagerPacket.suggestions;
     }
 }
diff --git a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
index 30702b888..012e6b0e0 100644
--- a/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/PingPacketHandler.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.net.handler;
 
-import net.minecraft.client.gui.SelectServerScreen;
+import net.minecraft.client.gui.ScreenSelectServer;
 import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.ServerAddress;
 import net.minecraft.core.net.ServerData;
@@ -16,12 +16,12 @@ public class PingPacketHandler
     extends PacketHandler
 {
     private boolean disconnected = false;
-    private final SelectServerScreen screen;
+    private final ScreenSelectServer screen;
     private final NetworkManager netManager;
     private final ServerData server;
     public static long startTime = 0;
 
-    public PingPacketHandler(SelectServerScreen screen, ServerData server)
+    public PingPacketHandler(ScreenSelectServer screen, ServerData server)
         throws IOException {
         this.screen = screen;
         this.server = server;
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
index 51546d8f0..66dc0cd80 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadDownloadImage.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.net.thread;
 
 import com.mojang.logging.LogUtils;
-import net.minecraft.client.render.texture.DownloadedTexture;
+import net.minecraft.client.render.texture.TextureDownloaded;
 import net.minecraft.client.render.ImageParser;
 import org.slf4j.Logger;
 
@@ -18,9 +18,9 @@ public class ThreadDownloadImage extends Thread {
 	
 	public final String url;
 	public final ImageParser imageParser;
-	public final DownloadedTexture texture;
+	public final TextureDownloaded texture;
 
-	public ThreadDownloadImage(DownloadedTexture texture, String url, ImageParser imageParser) {
+	public ThreadDownloadImage(TextureDownloaded texture, String url, ImageParser imageParser) {
 		this.texture = texture;
 		this.url = url;
 		this.imageParser = imageParser;
diff --git a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
index 7f28e0a8b..aa71ad74e 100644
--- a/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
+++ b/src/main/java/net/minecraft/client/net/thread/ThreadPingServer.java
@@ -1,6 +1,6 @@
 package net.minecraft.client.net.thread;
 
-import net.minecraft.client.gui.SelectServerScreen;
+import net.minecraft.client.gui.ScreenSelectServer;
 import net.minecraft.client.net.handler.PingPacketHandler;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.ServerAddress;
@@ -11,12 +11,12 @@ import net.minecraft.core.net.packet.PingHandshakePacket;
 public class ThreadPingServer
     extends Thread {
 
-    private final SelectServerScreen screen;
+    private final ScreenSelectServer screen;
     private final ServerData server;
     private boolean done = false;
     private PingPacketHandler netHandler = null;
 
-    public ThreadPingServer(SelectServerScreen screen, ServerData server) {
+    public ThreadPingServer(ScreenSelectServer screen, ServerData server) {
         this.screen = screen;
         this.server = server;
         ServerAddress address = server.getServerAddress();
